<template>
  <a-card :bordered="false">
    <div class="table-page-search-wrapper" @keyup.enter="handleEnter">
      <a-form layout="inline">
        <a-row :gutter="48">
          <a-col :md="8" :sm="24">
            <a-form-item label="关键字">
              <a-input v-model="queryParam.keyword" placeholder="请输入设备编号/仓库名称/设备名称/卡片编号"/>
            </a-form-item>
          </a-col>

          <a-col :md="8" :sm="24">
            <a-form-item label="仓库名称">
              <a-input v-model="queryParam.storeName" placeholder="请输入仓库名称"/>
            </a-form-item>
          </a-col>

          <a-col :md="8" :sm="24">
            <a-form-item label="设备型号">
              <a-select
                v-model="queryParam.modelId"
                placeholder="请选择">
                <a-select-option
                  v-for="(item,index) in modelList"
                  :key="index"
                  :label="item.nameModel"
                  :value="item.id">{{ item.nameModel }}
                </a-select-option>
              </a-select>
            </a-form-item>
          </a-col>

          <a-col :md="8" :sm="24">
            <a-form-item label="状态">
              <a-select v-model="queryParam.status" placeholder="请选择">
                <a-select-option
                  v-for="(label,value) in statusMap"
                  :key="value"
                  :label="label"
                  :value="parseInt(value)">{{ label }}
                </a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :md="8 || 24" :sm="24">
            <span class="table-page-search-submitButtons">
              <a-button type="primary" @click="$refs.table.refresh(true)">查询</a-button>
              <a-button style="margin-left: 8px" @click="resetSearchForm">重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>

    <div class="table-operator" v-if="targetId">
      <a-button type="primary" @click="()=> this.$emit('back')">返回</a-button>
    </div>

    <div class="table-operator" v-else>
      <!--<a-button v-if="$auth('sb-oils-add')" type="primary" icon="plus" @click="$refs.baseModalList.base()">新增</a-button>-->
      <a-button v-if="$auth('sb-oils-export')" type="primary" icon="download" @click="doExport">导出</a-button>

      <a-popconfirm
        style="margin-left: 8px"
        v-if="$auth('sb-oils-oil')"
        title="是否要加油所选数据？"
        @confirm="oilHandleList()">
        <a-button icon="edit" type="primary">
          批量加油
        </a-button>
      </a-popconfirm>

      <a-dropdown v-action:edit v-if="selectedRowKeys.length > 0 && $auth('sb-oils-oil')">
        <a-menu slot="overlay">
          <a-popconfirm title="是否要加油所选数据？" @confirm="oilHandleList()">
            <a-menu-item key="1"><a-icon type="edit" /><a>批量加油</a></a-menu-item>
          </a-popconfirm>
        </a-menu>
        <a-button style="margin-left: 8px">
          批量操作 <a-icon type="down" />
        </a-button>
      </a-dropdown>
    </div>

    <s-table
      ref="table"
      size="default"
      rowKey="id"
      :bordered="this.MyGlobalConstant.BORDERED"
      :columns="columns"
      :data="loadData"
      :alert="options.alert"
      :rowSelection="options.rowSelection"
      showPagination="auto"
    >
      <span slot="action" slot-scope="record">
        <template>
          <a @click="handleView(record)">查看</a>
          <operation-button
            v-if="$auth('sb-oils-oil')
              && (record.status === DictCache.VALUE.SB_OIL_STATUS.AGREE
              || record.status === DictCache.VALUE.SB_OIL_STATUS.OIL
              )"
            @click="handleHandle(record)"
          >加油</operation-button>
        </template>
      </span>
    </s-table>
    <base-form ref="baseModal" @ok="handleOk"/>
    <base-form-list ref="baseModalList" @ok="handleOk" />
    <execute-base-form ref="executeBaseForm" @ok="handleOk" />
    <audit-base-form ref="auditBaseForm" @ok="handleOk" />
    <execute-base-form-list ref="executeBaseFormList" @ok="handleOk" />
    <detail ref="detailModal"/>
  </a-card>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import BaseForm from './modules/BaseForm'
import BaseFormList from './modules/BaseFormList'
import Detail from './modules/Detail'
import ExecuteBaseForm from '@/views/sb/oil/modules/ExecuteBaseForm'
import AuditBaseForm from '@/views/sb/oil/modules/AuditBaseForm'
import ExecuteBaseFormList from '@/views/sb/oil/modules/ExecuteBaseFormList'
import { getSbOilTaskPage, deleteSbOils, fetchSbOil, exportSbOil } from '@/api/sb/oil'
import { querySbInfo } from '@/api/sb/model'

export default {
  name: 'SbOilList',
  components: {
    STable,
    Ellipsis,
    BaseForm,
    BaseFormList,
    ExecuteBaseFormList,
    ExecuteBaseForm,
    AuditBaseForm,
    Detail
  },
  props: {
    targetId: {
      type: String,
      default: null
    }
  },
  data () {
    return {
      // 查询参数
      queryParam: {
      },
      userInfo: this.$store.getters.userInfo,
      modelList: [],
      // 表头
      columns: [
        {
          title: '序号',
          dataIndex: 'index',
          customRender: (text, record, index) => {
            return `${(this.$refs.table.localPagination.current - 1) * this.$refs.table.localPagination.pageSize + index + 1}`
          }
        },
        {
          title: '设备名称',
          dataIndex: 'sbName'
        },
        {
          title: '设备编号',
          dataIndex: 'sbNo'
        },
        {
          title: '仓库名称',
          dataIndex: 'storeName'
        },
        {
          title: '申请人',
          dataIndex: 'userName'
        },
        {
          title: '申请油量',
          dataIndex: 'applyOil',
          customRender: (text, record, index) => {
            const result = this.BaseTool.Amount.formatter(text)
            if (this.BaseTool.String.isNotBlank(result)) {
              return result + '升'
            } else {
              return ''
            }
          }
        },
        {
          title: '实际加油量',
          dataIndex: 'realOil',
          customRender: (text, record, index) => {
            const result = this.BaseTool.Amount.formatter(text)
            if (this.BaseTool.String.isNotBlank(result)) {
              return result + '升'
            } else {
              return ''
            }
          }
        },
        {
          title: '状态',
          dataIndex: 'status',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.statusCustomRenderDict(this, text, record,
              this.DictCache.COLOR.SB_OIL_STATUS, this.statusMap)
          }
        },
        {
          title: '审批类型',
          dataIndex: 'auditType',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.getMapText(this.auditTypeMap, text)
          }
        },
        {
          title: '仓库管理员',
          dataIndex: 'storeUserName'
        },
        {
          title: '申请说明',
          dataIndex: 'applyRemark',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.customRenderWidth(this, text, '150px')
          }
        },
        {
          title: '审批说明',
          dataIndex: 'remark',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.customRenderWidth(this, text, '150px')
          }
        },
        {
          title: '加油说明',
          dataIndex: 'handleRemark',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.customRenderWidth(this, text, '150px')
          }
        },
        {
          title: '操作',
          key: 'action',
          width: '200px',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 下拉框map
      statusMap: {},
      auditTypeMap: {},
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          id: this.targetId,
          ...this.queryParam
        }
        return getSbOilTaskPage(parameter)
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange,
          getCheckboxProps: record => ({
            props: {
              disabled: !(record.status === this.DictCache.VALUE.SB_OIL_STATUS.AGREE ||
                record.status === this.DictCache.VALUE.SB_OIL_STATUS.OIL
              ),
              name: record.id
            }
          })
        }
      },
      optionAlertShow: false
    }
  },
  created () {
    this.initData()
    // 下拉框map
    this.statusMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SB_OIL_STATUS)
    this.auditTypeMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SB_OIL_AUDIT_TYPE)
    this.tableOption()
  },
  methods: {
    initData () {
      querySbInfo({}).then(res => {
        this.modelList = res.data
      })
      if (this.targetId) {
        fetchSbOil({ id: this.targetId }).then(res => {
          const record = res.data
          if (this.$auth('sb-oils-oil') &&
            (record.status === this.DictCache.VALUE.SB_OIL_STATUS.AGREE ||
              record.status === this.DictCache.VALUE.SB_OIL_STATUS.OIL
            )) {
            const modal = this.$refs.executeBaseForm
            modal.base(record)
          } else {
            const modal = this.$refs.detailModal
            modal.base(res.data)
          }
        })
      }
    },
    tableOption () {
      if (!this.optionAlertShow && !this.targetId) {
        this.options = {
          alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            getCheckboxProps: record => ({
              props: {
                disabled: !(record.status === this.DictCache.VALUE.SB_OIL_STATUS.AGREE ||
                  record.status === this.DictCache.VALUE.SB_OIL_STATUS.OIL
                ),
                name: record.id
              }
            })
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    oilHandleList () {
      const ids = this.selectedRows.map(item => item.id)
      if (this.BaseTool.Object.isBlank(ids) || ids.length <= 0) {
        this.$message.info('请选择要加油的记录')
        return
      }
      const modal = this.$refs.executeBaseFormList
      modal.base(ids)
    },
    batchDelete (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要删除的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deleteSbOils(ids).then(res => {
        this.$message.info('删除成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleEdit (record) {
      fetchSbOil({ id: record.id }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(res.data)
      })
    },
    handleConfirm (record) {
      fetchSbOil({ id: record.id }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(res.data)
      })
    },
    handleHandle (record) {
      fetchSbOil({ id: record.id }).then(res => {
        const modal = this.$refs.executeBaseForm
        modal.base(res.data)
      })
    },
    auditHandle (record) {
      fetchSbOil({ id: record.id }).then(res => {
        const modal = this.$refs.auditBaseForm
        modal.base(res.data)
      })
    },
    handleView (record) {
      fetchSbOil({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data)
      })
    },
    handleOk () {
      this.$refs.table.clearSelected()
      this.$refs.table.refresh()
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    resetSearchForm () {
      this.queryParam = {
      }
      this.$refs.table.refresh(true)
    },
    doExport () {
      const parameter = {
        ...this.queryParam
      }
      exportSbOil(parameter).then(file => {
        this.BaseTool.UPLOAD.downLoadExportExcel(file)
      })
    },
    handleEnter () {
      this.$refs.table.refresh(true)
    }
  }
}
</script>
